﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading.Tasks;



namespace FT4222H_Csharp
{
	class Program
	{
        //ftd2xx DLL loading

        [DllImport("ftd2xx.dll", CallingConvention = CallingConvention.Cdecl)]
		public static extern FT_STATUS FT_CreateDeviceInfoList(ref UInt32 numdevs);

        [DllImport("ftd2xx.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT_STATUS FT_GetDeviceInfoDetail(UInt32 index, ref UInt32 flags, ref FT_DEVICE chiptype, ref UInt32 id, ref UInt32 locid, byte[] serialnumber, byte[] description, ref IntPtr ftHandle);

        [DllImport("ftd2xx.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT_STATUS FT_OpenEx(String SerialNumber, int dwFlags, ref IntPtr ftHandle);

        [DllImport("ftd2xx.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT_STATUS FT_SetLatencyTimer(IntPtr ftHandle, byte time);

        [DllImport("ftd2xx.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT_STATUS FT_SetUSBParameters(IntPtr ftHandle, ulong IntransferSize, ulong OutTransferSize);


        //FT4222H DLL loadning

        [DllImport("LibFT4222-64.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT4222_STATUS FT4222_SetClock(IntPtr ftHandle, FT4222_ClockRate clk);

        [DllImport("LibFT4222-64.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT4222_STATUS FT4222_GetClock(IntPtr ftHandle, ref FT4222_ClockRate clk);

        [DllImport("LibFT4222-64.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT4222_STATUS FT4222_SPIMaster_Init(IntPtr ftHandle, FT4222_SPIMode ioLine, FT4222_SPIClock clock, FT4222_SPICPOL cpol, FT4222_SPICPHA cpha, Byte ssoMap);

        [DllImport("LibFT4222-64.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern FT4222_STATUS FT4222_SPIMaster_SingleReadWrite(IntPtr ftHandle, ref byte readBuffer, ref byte writeBuffer, ushort bufferSize, ref ushort sizeTransferred, bool isEndTransaction);


        public enum FT_STATUS
        {
            FT_OK,
            FT_INVALID_HANDLE,
            FT_DEVICE_NOT_FOUND,
            FT_DEVICE_NOT_OPENED,
            FT_IO_ERROR,
            FT_INSUFFICIENT_RESOURCES,
            FT_INVALID_PARAMETER,
            FT_INVALID_BAUD_RATE,

            FT_DEVICE_NOT_OPENED_FOR_ERASE,
            FT_DEVICE_NOT_OPENED_FOR_WRITE,
            FT_FAILED_TO_WRITE_DEVICE,
            FT_EEPROM_READ_FAILED,
            FT_EEPROM_WRITE_FAILED,
            FT_EEPROM_ERASE_FAILED,
            FT_EEPROM_NOT_PRESENT,
            FT_EEPROM_NOT_PROGRAMMED,
            FT_INVALID_ARGS,
            FT_NOT_SUPPORTED,
            FT_OTHER_ERROR,
            FT_DEVICE_LIST_NOT_READY,
        }
        
        public enum FT_DEVICE
        {
            FT_DEVICE_BM,
            FT_DEVICE_AM,
            FT_DEVICE_100AX,
            FT_DEVICE_UNKNOWN,
            FT_DEVICE_2232C,
            FT_DEVICE_232R,
            FT_DEVICE_2232H,
            FT_DEVICE_4232H,
            FT_DEVICE_232H,
            FT_DEVICE_X_SERIES,
            FT_DEVICE_4222H_0,
            FT_DEVICE_4222H_1_2,
            FT_DEVICE_4222H_3,
            FT_DEVICE_4222_PROG,
            FT_DEVICE_900,
            FT_DEVICE_UMFTPD3A,
        };

        public enum FT4222_STATUS
        {
            FT4222_OK,
            FT4222_INVALID_HANDLE,
            FT4222_DEVICE_NOT_FOUND,
            FT4222_DEVICE_NOT_OPENED,
            FT4222_IO_ERROR,
            FT4222_INSUFFICIENT_RESOURCES,
            FT4222_INVALID_PARAMETER,
            FT4222_INVALID_BAUD_RATE,
            FT4222_DEVICE_NOT_OPENED_FOR_ERASE,
            FT4222_DEVICE_NOT_OPENED_FOR_WRITE,
            FT4222_FAILED_TO_WRITE_DEVICE,
            FT4222_EEPROM_READ_FAILED,
            FT4222_EEPROM_WRITE_FAILED,
            FT4222_EEPROM_ERASE_FAILED,
            FT4222_EEPROM_NOT_PRESENT,
            FT4222_EEPROM_NOT_PROGRAMMED,
            FT4222_INVALID_ARGS,
            FT4222_NOT_SUPPORTED,
            FT4222_OTHER_ERROR,
            FT4222_DEVICE_LIST_NOT_READY,

            FT4222_DEVICE_NOT_SUPPORTED = 1000,        // FT_STATUS extending message
            FT4222_CLK_NOT_SUPPORTED,     // spi master do not support 80MHz/CLK_2
            FT4222_VENDER_CMD_NOT_SUPPORTED,
            FT4222_IS_NOT_SPI_MODE,
            FT4222_IS_NOT_I2C_MODE,
            FT4222_IS_NOT_SPI_SINGLE_MODE,
            FT4222_IS_NOT_SPI_MULTI_MODE,
            FT4222_WRONG_I2C_ADDR,
            FT4222_INVAILD_FUNCTION,
            FT4222_INVALID_POINTER,
            FT4222_EXCEEDED_MAX_TRANSFER_SIZE,
            FT4222_FAILED_TO_READ_DEVICE,
            FT4222_I2C_NOT_SUPPORTED_IN_THIS_MODE,
            FT4222_GPIO_NOT_SUPPORTED_IN_THIS_MODE,
            FT4222_GPIO_EXCEEDED_MAX_PORTNUM,
            FT4222_GPIO_WRITE_NOT_SUPPORTED,
            FT4222_GPIO_PULLUP_INVALID_IN_INPUTMODE,
            FT4222_GPIO_PULLDOWN_INVALID_IN_INPUTMODE,
            FT4222_GPIO_OPENDRAIN_INVALID_IN_OUTPUTMODE,
            FT4222_INTERRUPT_NOT_SUPPORTED,
            FT4222_GPIO_INPUT_NOT_SUPPORTED,
            FT4222_EVENT_NOT_SUPPORTED,
        };

        public enum FT4222_ClockRate
        {
            SYS_CLK_60 = 0,
            SYS_CLK_24,
            SYS_CLK_48,
            SYS_CLK_80,

        };

        public enum FT4222_SPIMode
        {
            SPI_IO_NONE = 0,
            SPI_IO_SINGLE = 1,
            SPI_IO_DUAL = 2,
            SPI_IO_QUAD = 4,

        };

        public enum FT4222_SPIClock
        {
            CLK_NONE = 0,
            CLK_DIV_2,      // 1/2   System Clock
            CLK_DIV_4,      // 1/4   System Clock
            CLK_DIV_8,      // 1/8   System Clock
            CLK_DIV_16,     // 1/16  System Clock
            CLK_DIV_32,     // 1/32  System Clock
            CLK_DIV_64,     // 1/64  System Clock
            CLK_DIV_128,    // 1/128 System Clock
            CLK_DIV_256,    // 1/256 System Clock
            CLK_DIV_512,    // 1/512 System Clock

        };

        public enum FT4222_SPICPOL
        {
            CLK_IDLE_LOW = 0,
            CLK_IDLE_HIGH = 1,
        };

        public enum FT4222_SPICPHA
        {
            CLK_LEADING = 0,
            CLK_TRAILING = 1,
        };


        public struct _ft_device_list_info_node
        {
            public uint Flags;
            public FT_DEVICE Type;
            public uint ID;
            public uint LocId;
            public IntPtr ftHandle;
        }




        public static ushort ReadRegister(IntPtr FThandle, byte RegisterAddress)
        {
            byte AppendedRegAddres = Convert.ToByte(RegisterAddress * 4 + 2);

            //Create a read- and writebuffer for data to be read and writen to the DISB registers.
            byte[] ReadBuffer = new byte[3]; byte[] WriteBuffer = new byte[3];

            //Used as the adress for which the number of bytes being read or writen after each ReadWrite command is registed.
            ushort SizeTransferred = 0;

            WriteBuffer[0] = AppendedRegAddres;
            WriteBuffer[1] = 0x0;
            WriteBuffer[2] = 0x0;

            FT4222_SPIMaster_SingleReadWrite(FThandle, ref ReadBuffer[0], ref WriteBuffer[0], (ushort)WriteBuffer.Length, ref SizeTransferred, true);
        
            ushort RegisterValue = Convert.ToUInt16(ReadBuffer[1] << 8 | ReadBuffer[2] & 0xff);
            return RegisterValue;
        }

        public static void SetRegister(IntPtr FThandle, byte RegisterAddress, UInt16 NewRegisterValue)
        {
            byte AppendedRegAddres = Convert.ToByte(RegisterAddress * 4 );

            //Create a read- and writebuffer for data to be read and writen to the DISB registers.
            byte[] ReadBuffer = new byte[3]; byte[] WriteBuffer = new byte[3];
            byte MSB = 0; byte LSB = 0;

            //Used as the adress for which the number of bytes being read or writen after each ReadWrite command is registed.
            ushort SizeTransferred = 0;



            WriteBuffer[0] = AppendedRegAddres;
            LSB = Convert.ToByte(NewRegisterValue & 0xff);
            MSB = Convert.ToByte(NewRegisterValue  >> 8);

            WriteBuffer[1] = MSB;
            WriteBuffer[2] = LSB;
            /*
            Console.WriteLine("NewRegisterValue{0}: ", NewRegisterValue);
            Console.WriteLine("MSB{0}: ", MSB);
            Console.WriteLine("LSB{0}: ", LSB);
            */
            FT4222_SPIMaster_SingleReadWrite(FThandle, ref ReadBuffer[0], ref WriteBuffer[0], (ushort)WriteBuffer.Length, ref SizeTransferred, true);

        }

        public static UInt16[] GetSpectrum(IntPtr FThandleREG, IntPtr FThandleStream)
        {
            // Writing to the Sensor Control register 8.
            SetRegister(FThandleREG, 8, 0x10);
            // Trigger an exposure
            SetRegister(FThandleREG, 8, 0x01);

            ushort FirstPixel = ReadRegister(FThandleREG, 23);
            ushort LastPixel = ReadRegister(FThandleREG, 24);
            

            UInt16 datalength = Convert.ToUInt16((LastPixel - FirstPixel + 1) * 2);
            byte[] NewReadFramebuffer = new byte[datalength];
            byte[] NewWriteFramebuffer = new byte[datalength];
            UInt16[] Spectrum = new UInt16[datalength / 2];

            ushort NumberOfPixReady = 0;
            while (LastPixel - FirstPixel > NumberOfPixReady)
            {
                NumberOfPixReady = ReadRegister(FThandleREG, 12);
            }

            ushort SizeTransferred = 0;

            FT4222_SPIMaster_SingleReadWrite(FThandleStream, ref NewReadFramebuffer[0], ref NewWriteFramebuffer[0], datalength, ref SizeTransferred, true);

            int spectrumIncrement = 0;
            for (int i = 0; i < datalength; i += 2)
            {
                Spectrum[spectrumIncrement] = Convert.ToUInt16(NewReadFramebuffer[i] << 8 | NewReadFramebuffer[i + 1]);
                spectrumIncrement ++;
            }

            return Spectrum;

        }


        static void Main(string[] args)
		{
		

            //Status for command
            FT_STATUS ftStatus = 0;

            // Check devices
            UInt32 numOfDevices = 0;
            ftStatus = FT_CreateDeviceInfoList(ref numOfDevices);
            Console.WriteLine("Number of devices {0}", numOfDevices);

            //Device info list - Read from Struct
            _ft_device_list_info_node devInfo = new _ft_device_list_info_node();

            //Create devicelist - Run through number of devices availble 
            for (uint iDev = 0; iDev < numOfDevices; iDev++)
            {
                byte[] SerialNumber = new byte[8];
                byte[] Description = new byte[8];

                // Get information of device number = iDev
                ftStatus = FT_GetDeviceInfoDetail(iDev, ref devInfo.Flags, 
                                         ref devInfo.Type, ref devInfo.ID, 
                                         ref devInfo.LocId, SerialNumber,
                                         Description, ref devInfo.ftHandle);

                //If Status returned by FT_GetDeviceInfoDetail = FT_OK, Print device information.
                if (FT_STATUS.FT_OK == ftStatus)
                {
                    Console.WriteLine("FLAGS: {0}", devInfo.Flags);
                    Console.WriteLine("Device type (Chipset): {0}", devInfo.Type);
                    Console.WriteLine("Device ID: {0:X}", devInfo.ID);
                    Console.WriteLine("Location ID: {0:X}", devInfo.LocId);
                    Console.WriteLine("Serial Number: {0}", Encoding.ASCII.GetString(SerialNumber));
                    Console.WriteLine("Device describtion: {0}", Encoding.ASCII.GetString(Description));
                } 
            }

            //Opening Device FT4222H, A, B and C. With three corresponding Handles.
            IntPtr ftHandleOutStream = new IntPtr();
            IntPtr ftHandleOutCom = new IntPtr();
            IntPtr ftHandleOutGPIO = new IntPtr();

            ftStatus = FT_OpenEx("A", 1, ref ftHandleOutStream);
            if (FT_STATUS.FT_OK != ftStatus) { Console.WriteLine("Could not open device"); }
            ftStatus = FT_OpenEx("B", 1, ref ftHandleOutCom);
            if (FT_STATUS.FT_OK != ftStatus) { Console.WriteLine("Could not open device"); }
            ftStatus = FT_OpenEx("C", 1, ref ftHandleOutGPIO);
            if (FT_STATUS.FT_OK != ftStatus) { Console.WriteLine("Could not open device"); }

            /*	
            *********************************************************************
            *********************************************************************
            Initialize Device Master SPI
            *********************************************************************
            *********************************************************************
            */
            byte UcLatency = 20;
            FT_SetLatencyTimer(ftHandleOutStream, UcLatency);

            ulong OutTransferSize = 4096;
            ulong InTransferSize = 65536;
            FT_SetUSBParameters(ftHandleOutStream, InTransferSize, OutTransferSize);

            // MASTER SPI INTIALIZE 
            //SPI Status
            FT4222_STATUS ft4222Status;
            ft4222Status = FT4222_SetClock(ftHandleOutStream, 0);

            
            // Init FT4222 SPI Master of ftHandleOutCom and ftHandleOutStream.
            ft4222Status = FT4222_SPIMaster_Init(ftHandleOutCom, FT4222_SPIMode.SPI_IO_SINGLE, FT4222_SPIClock.CLK_DIV_4, FT4222_SPICPOL.CLK_IDLE_LOW, FT4222_SPICPHA.CLK_TRAILING, 2);
            ft4222Status = FT4222_SPIMaster_Init(ftHandleOutStream, FT4222_SPIMode.SPI_IO_SINGLE, FT4222_SPIClock.CLK_DIV_4, FT4222_SPICPOL.CLK_IDLE_LOW, FT4222_SPICPHA.CLK_TRAILING, 3);


            //Read different values from DISB registers
            ushort PCB_SN = ReadRegister(ftHandleOutCom, 1);
            Console.WriteLine("PCB SERIAL NUMBER {0}", PCB_SN);

            ushort HardwareVersion = ReadRegister(ftHandleOutCom, 2);
            Console.WriteLine("Hardware Version {0}", HardwareVersion);

            ushort FirmwareVersion = ReadRegister(ftHandleOutCom, 3);
            Console.WriteLine("Firmware Version {0}", FirmwareVersion);

            ushort DetectorType = ReadRegister(ftHandleOutCom, 4);
            Console.WriteLine("Detector Type {0}", DetectorType);

            ushort PixelPerImage = ReadRegister(ftHandleOutCom, 5);
            Console.WriteLine("Pixels per image {0}", PixelPerImage);

            ushort NumberofCaliChars = ReadRegister(ftHandleOutCom, 6);
            Console.WriteLine("Number of calibration Chars {0}", NumberofCaliChars);

            //Read Wave calibration coefficients. Each coefficients is comprised of 14 Chars. 
            char[] calibrationChars = new char[14];
            for (int i = 0; i < NumberofCaliChars / 14; i++)
            {
                string CombinedCalibrationChar = "";
                for (int j = 0; j < 14; j++)
                {
                    calibrationChars[j] = Convert.ToChar(ReadRegister(ftHandleOutCom, 7));
                    CombinedCalibrationChar += calibrationChars[j];
                }
                Console.WriteLine("Calibration coefficient: {0}", CombinedCalibrationChar);
            }


            //Read different values from DISB registers
            ushort Temperature = ReadRegister(ftHandleOutCom, 11);
            Console.WriteLine("Temperature measured {0}", Temperature);

            ushort TriggerDelayLSB = ReadRegister(ftHandleOutCom, 13);
            ushort TriggerDelayMSB = ReadRegister(ftHandleOutCom, 14);
            UInt32 TriggerDelay = Convert.ToUInt32(TriggerDelayMSB << 16 | TriggerDelayLSB );
            Console.WriteLine("Total set trigger delay  {0}", TriggerDelay);

            ushort ADCGain = ReadRegister(ftHandleOutCom, 15);
            Console.WriteLine("ADC gain {0}", ADCGain);

            ushort ADCOffset = ReadRegister(ftHandleOutCom, 16);
            Console.WriteLine("ADC Offset {0}", ADCOffset);

            ushort FirstPixel = ReadRegister(ftHandleOutCom, 23);
            Console.WriteLine("First pixel to be read out {0}", FirstPixel);

            ushort LastPixel = ReadRegister(ftHandleOutCom, 24);
            Console.WriteLine("Last pixel to be read out {0}", LastPixel);


            /*	*********************************************************************
            *********************************************************************
            Write integration time to DISB Register
            *********************************************************************
            *********************************************************************
            */
            // Setting integration time of Register 10 MSB. 
            SetRegister(ftHandleOutCom, 10, 0);

            // Setting integration time of Register 9 LSB. 
            SetRegister(ftHandleOutCom, 9, 50000);


            ushort LSB_10ms = ReadRegister(ftHandleOutCom, 9);
            ushort MSB_10ms = ReadRegister(ftHandleOutCom, 10);
            UInt32 IntegrationTime = Convert.ToUInt32(MSB_10ms << 16 | LSB_10ms);
            
            Console.WriteLine("\nSet Integration time in ms {0}", IntegrationTime * 0.0002);

            /*
           *********************************************************************
           *********************************************************************
           Read spectrum from framebuffer.
           *********************************************************************
           *********************************************************************
           */
            
             //Runs GetSpectrum function
             var GetSpectrumFunction = Task.Run(() =>
             {
                 return GetSpectrum(ftHandleOutCom, ftHandleOutStream);
             });

             //Create as boolean value to whether or not the GetSpectrum function has returned a spectrum within the timeout limit. 
             bool isCompletedSuccessfully = GetSpectrumFunction.Wait(TimeSpan.FromMilliseconds(1000));

             //If a spectrum was returned, print it to terminal
             //If no spectrum returned, print timeout message.
             if (isCompletedSuccessfully)
             {
                 for (int i = 0; i < GetSpectrumFunction.Result.Length; i++)
                 {
                     Console.Write("{0} ", GetSpectrumFunction.Result[i]);
                 }
             }
             else
             {
                 Console.WriteLine("No Spectrum was obtained before timeout");
             }

            /*	*********************************************************************
            *********************************************************************
            Write integration time to DISB Register
            *********************************************************************
            *********************************************************************
            */
            // Setting integration time of Register 10 MSB. 
            SetRegister(ftHandleOutCom, 10, 7);
            
            // Setting integration time of Register 9 LSB. 
            SetRegister(ftHandleOutCom, 9, 41248);
            

            ushort LSB_100ms = ReadRegister(ftHandleOutCom, 9);
            ushort MSB_100ms = ReadRegister(ftHandleOutCom, 10);
            IntegrationTime = Convert.ToUInt32(MSB_100ms << 16 | LSB_100ms & 0xffff);
            Console.WriteLine("\n\nSet Integration time in ms {0}", IntegrationTime * 0.0002);



            /*
            *********************************************************************
            *********************************************************************
            Read spectrum from framebuffer.
            *********************************************************************
            *********************************************************************
            */
            
            //Runs GetSpectrum function
            GetSpectrumFunction = Task.Run(() =>
            {
                return GetSpectrum(ftHandleOutCom, ftHandleOutStream);
            });

            //Create as boolean value to whether or not the GetSpectrum function has returned a spectrum within the timeout limit. 
            isCompletedSuccessfully = GetSpectrumFunction.Wait(TimeSpan.FromMilliseconds(1000));

            //If a spectrum was returned, print it to terminal
            //If no spectrum returned, print timeout message.
            if (isCompletedSuccessfully)
            {
                for (int i = 0; i < GetSpectrumFunction.Result.Length; i++)
                {
                    Console.Write("{0} ", GetSpectrumFunction.Result[i]);
                }
            }
            else
            {
                Console.WriteLine("No Spectrum was obtained before timeout");
            }
            
           
        }
	}
}
